﻿using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace KollisionMedCirklar
{
    public class Game1 : Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        //Grafik
        Texture2D ship, meteor, hit;

        //Positioner
        double playerX, playerY;
        double meteorX = 300, meteorY = 200;

        //Radier
        double playerRadie = 24;
        double meteorRadie = 55;

        //Har vi träff?
        bool bHit = false;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            graphics.PreferredBackBufferWidth = 640;
            graphics.PreferredBackBufferHeight = 480;
        }

        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            ship = Content.Load<Texture2D>("ship");
            meteor = Content.Load<Texture2D>("meteor");
            hit = Content.Load<Texture2D>("hit");
        }

        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        protected override void Update(GameTime gameTime)
        {
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed || Keyboard.GetState().IsKeyDown(Keys.Escape))
                Exit();

            MouseState m = Mouse.GetState();
            playerX = m.X;
            playerY = m.Y;

            //Kolla om vi kolliderar
            double xdiff = playerX - meteorX;
            double ydiff = playerY - meteorY;

            if ((xdiff * xdiff + ydiff * ydiff) < (playerRadie + meteorRadie) * (playerRadie + meteorRadie))
            {
                bHit = true;
            }
            else
            {
                bHit = false;
            }

            base.Update(gameTime);
        }

        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin();
            spriteBatch.Draw(meteor, new Rectangle((int)meteorX - 55, (int)meteorY - 55, 110, 110), Color.White);
            spriteBatch.Draw(ship, new Rectangle((int)playerX - 24, (int)playerY - 30, 48, 60), Color.White);

            if (bHit)
            {
                spriteBatch.Draw(hit, new Rectangle(150, 10, 150, 50), Color.White);
            }

            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
